Index: drivers/video/radeonfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/radeonfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/radeonfb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/radeonfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -2836,28 +4250,58 @@
 	 * including PCI config registers, clocks, AGP conf, ...)
 	 */
 	if (suspend) {
-		/* Make sure CRTC2 is reset.  Remove that the day
-		 * we decide to actually use CRTC2 and replace it with
-		 * real code for disabling the CRTC2 output during sleep.
+		/* Disable dynamic power management of clocks for the
+		 * duration of the suspend/resume process
+		 */
+		radeon_pm_disable_dynamic_mode(rinfo);
+		/* Save some registers */
+		radeon_pm_save_regs(rinfo);
+
+		/* Prepare mobility chips for suspend
 		 */
+		if (rinfo->arch == RADEON_M6 || rinfo->arch == RADEON_M7 || rinfo->arch == RADEON_M9) {
+			/* Program V2CLK */
+			radeon_pm_program_v2clk(rinfo);
+		
+			/* Disable IO PADs */
+			radeon_pm_disable_iopad(rinfo);
+
+			/* Set low current */
+			radeon_pm_low_current(rinfo);
 
-		pci_read_config_word(rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL,
-				     &pwr_cmd);
+			/* Prepare chip for power management */
+			radeon_pm_setup_for_suspend(rinfo);
+
+			/* Reset the MDLL */
+			OUTPLL( pllMDLL_CKO, INPLL( pllMDLL_CKO) | MDLL_CKO__MCKOA_RESET | MDLL_CKO__MCKOB_RESET);
+		}
 
-		/* Switch PCI power managment to D2 */
-		pci_write_config_word(rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL,
-				      (pwr_cmd & ~PCI_PM_CTRL_STATE_MASK)
-				      | 2);
-		pci_read_config_word(rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL,
-				     &pwr_cmd);
+		/* Switch PCI power managment to D2. */
+		for (;;) {
+			pci_read_config_word(
+				rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL,
+				&pwr_cmd);
+			if (pwr_cmd & 2)
+				break;			
+			pci_write_config_word(
+				rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL,
+				(pwr_cmd & ~PCI_PM_CTRL_STATE_MASK) | 2);
+			mdelay(500);
+		}
 	} else {
 		/* Switch back PCI powermanagment to D0 */
-		mdelay(100);
+		mdelay(200);
 		pci_write_config_word(rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL, 0);
-		mdelay(100);
-		pci_read_config_word(rinfo->pdev, rinfo->pm_reg+PCI_PM_CTRL,
-				     &pwr_cmd);
-		mdelay(100);
+		mdelay(500);
+
+		/* Reset the SDRAM controller */
+		if (rinfo->arch == RADEON_M6 || rinfo->arch == RADEON_M7 || rinfo->arch == RADEON_M9)
+			radeon_pm_full_reset_sdram(rinfo);
+		
+		/* Restore some registers */
+		radeon_pm_restore_regs(rinfo);
+		radeon_pm_enable_dynamic_mode(rinfo);
+		mdelay(10);
 	}
 }
 
@@ -2866,19 +4310,21 @@
  * and restore it when we wake up again.
  */
 
-int radeon_sleep_notify(struct pmu_sleep_notifier *self, int when)
+static int radeon_sleep_notify(struct pmu_sleep_notifier *self, int when)
 {
 	struct radeonfb_info *rinfo;
 
 	for (rinfo = board_list; rinfo != NULL; rinfo = rinfo->next) {
 		struct fb_fix_screeninfo fix;
 		int nb;
+	        struct display *disp;  
 
-		switch (rinfo->chipset) {
-			case PCI_DEVICE_ID_RADEON_LW:
-			case PCI_DEVICE_ID_RADEON_LY:
-			case PCI_DEVICE_ID_RADEON_LZ:
-			case PCI_DEVICE_ID_RADEON_PM:
+        	disp = (rinfo->currcon < 0) ? rinfo->info.disp : &fb_display[rinfo->currcon];
+
+		switch (rinfo->arch) {
+			case RADEON_M6:
+			case RADEON_M7:
+			case RADEON_M9:
 				break;
 			default:
 				return PBOOK_SLEEP_REFUSE;
@@ -2888,72 +4334,45 @@
 		nb = fb_display[fg_console].var.yres * fix.line_length;
 
 		switch (when) {
-			case PBOOK_SLEEP_REQUEST:
-#if 0
-				rinfo->save_framebuffer = vmalloc(nb);
-				if (rinfo->save_framebuffer == NULL)
-					return PBOOK_SLEEP_REFUSE;
-#endif
-				break;
-			case PBOOK_SLEEP_REJECT:
-#if 0
-				if (rinfo->save_framebuffer) {
-					vfree(rinfo->save_framebuffer);
-					rinfo->save_framebuffer = 0;
-				}
-#endif
-				break;
 			case PBOOK_SLEEP_NOW:
-				radeon_engine_idle();
-				radeon_engine_reset();
-				radeon_engine_idle();
+				acquire_console_sem();
+				disp->dispsw = &fbcon_dummy;
 
-#if 0
-				/* Backup framebuffer content */
-				if (rinfo->save_framebuffer)
-					memcpy_fromio(rinfo->save_framebuffer,
-						      (void *)rinfo->fb_base,
-						      nb);
-#endif
+				if (!noaccel) {
+					/* Make sure engine is idle and reset */
+					radeon_engine_idle();
+					radeon_engine_reset();
+					radeon_engine_idle();
+				}
 
 				/* Blank display and LCD */
 				radeonfb_blank(VESA_POWERDOWN+1,
 					       (struct fb_info *)rinfo);
 
 				/* Sleep */
+				rinfo->asleep = 1;
 				radeon_set_suspend(rinfo, 1);
-
+				release_console_sem();
+				
 				break;
 			case PBOOK_WAKE:
-				/* Wakeup */
+				acquire_console_sem();
+				/* Wakeup chip*/
 				radeon_set_suspend(rinfo, 0);
 
-				radeon_engine_reset();
-				if (!noaccel) {
+				/* Re-set mode */
+				rinfo->asleep = 0;
+				radeon_load_video_mode(rinfo, &disp->var);
+				if ((disp->var.accel_flags & FB_ACCELF_TEXT) && !noaccel)
 					radeon_engine_init(rinfo);
-					radeon_engine_reset();
-				}
-
-#if 0
-				/* Restore framebuffer content */
-				if (rinfo->save_framebuffer) {
-					memcpy_toio((void *)rinfo->fb_base,
-						    rinfo->save_framebuffer,
-						    nb);
-					vfree(rinfo->save_framebuffer);
-					rinfo->save_framebuffer = 0;
-				}
-#endif
-
-				if (rinfo->currcon_display) {
-					radeonfb_set_var(&rinfo->currcon_display->var, rinfo->currcon,
-							 (struct fb_info *) rinfo);
-					radeon_set_dispsw(rinfo, rinfo->currcon_display);
-					do_install_cmap(rinfo->currcon,
-							(struct fb_info *)rinfo);
-				}
+				do_install_cmap(rinfo->currcon < 0 ? 0 : rinfo->currcon,
+						(struct fb_info *)rinfo);
+				/* Allow fbdev to tap us again */
+				radeon_set_dispsw(rinfo, disp);
 
+				/* Unblank screen */
 				radeonfb_blank(0, (struct fb_info *)rinfo);
+				release_console_sem();
 				break;
 		}
 	}
@@ -2973,6 +4392,7 @@
 {
 	struct radeonfb_info *rinfo = (struct radeonfb_info *)(p->fb_info);
 	u32 dp_cntl = DST_LAST_PEL;
+	u32 dp_cntl_save = 0;
 
 	srcx *= fontwidth(p);
 	srcy *= fontheight(p);
@@ -2982,17 +4402,19 @@
 	height *= fontheight(p);
 
 	if (srcy < dsty) {
-		srcy += height - 1;
-		dsty += height - 1;
+		srcy += height;
+		dsty += height;
 	} else
 		dp_cntl |= DST_Y_TOP_TO_BOTTOM;
 
 	if (srcx < dstx) {
-		srcx += width - 1;
-		dstx += width - 1;
+		srcx += width;
+		dstx += width;
 	} else
 		dp_cntl |= DST_X_LEFT_TO_RIGHT;
 
+	dp_cntl_save = INREG(DP_CNTL);
+
 	radeon_fifo_wait(6);
 	OUTREG(DP_GUI_MASTER_CNTL, (rinfo->dp_gui_master_cntl |
 				    GMC_BRUSH_NONE |
@@ -3004,11 +4426,39 @@
 	OUTREG(SRC_Y_X, (srcy << 16) | srcx);
 	OUTREG(DST_Y_X, (dsty << 16) | dstx);
 	OUTREG(DST_HEIGHT_WIDTH, (height << 16) | width);
+
+	radeon_fifo_wait(1);
+	OUTREG(DP_CNTL, dp_cntl_save);
+
+	radeon_engine_idle();
+}
+
+
+
+static void radeon_rectfill(struct radeonfb_info *rinfo,
+			    int dsty, int dstx,
+			    int height, int width,
+			    u32 clr)
+{
+	radeon_fifo_wait(6);
+	OUTREG(DP_GUI_MASTER_CNTL, (rinfo->dp_gui_master_cntl |
+				    GMC_BRUSH_SOLID_COLOR |
+				    GMC_SRC_DATATYPE_COLOR |
+				    ROP3_P));
+	OUTREG(DP_BRUSH_FRGD_CLR, clr);
+	OUTREG(DP_WRITE_MSK, 0xffffffff);
+	OUTREG(DP_CNTL, (DST_X_LEFT_TO_RIGHT | DST_Y_TOP_TO_BOTTOM));
+	OUTREG(DST_Y_X, (dsty << 16) | dstx);
+	OUTREG(DST_WIDTH_HEIGHT, (width << 16) | height);
+
+	radeon_engine_idle();
 }
 
 
 
-static void fbcon_radeon_clear(struct vc_data *conp, struct display *p,
+#ifdef FBCON_HAS_CFB8
+
+static void fbcon_radeon8_clear(struct vc_data *conp, struct display *p,
 			       int srcy, int srcx, int height, int width)
 {
 	struct radeonfb_info *rinfo = (struct radeonfb_info *)(p->fb_info);
@@ -3023,25 +4473,15 @@
 	width *= fontwidth(p);
 	height *= fontheight(p);
 
-	radeon_fifo_wait(6);
-	OUTREG(DP_GUI_MASTER_CNTL, (rinfo->dp_gui_master_cntl |
-				    GMC_BRUSH_SOLID_COLOR |
-				    GMC_SRC_DATATYPE_COLOR |
-				    ROP3_P));
-	OUTREG(DP_BRUSH_FRGD_CLR, clr);
-	OUTREG(DP_WRITE_MSK, 0xffffffff);
-	OUTREG(DP_CNTL, (DST_X_LEFT_TO_RIGHT | DST_Y_TOP_TO_BOTTOM));
-	OUTREG(DST_Y_X, (srcy << 16) | srcx);
-	OUTREG(DST_WIDTH_HEIGHT, (width << 16) | height);
+	radeon_rectfill(rinfo, srcy, srcx, height, width, clr);
 }
 
 
 
-#ifdef FBCON_HAS_CFB8
 static struct display_switch fbcon_radeon8 = {
 	setup:			fbcon_cfb8_setup,
 	bmove:			fbcon_radeon_bmove,
-	clear:			fbcon_radeon_clear,
+	clear:			fbcon_radeon8_clear,
 	putc:			fbcon_cfb8_putc,
 	putcs:			fbcon_cfb8_putcs,
 	revc:			fbcon_cfb8_revc,
@@ -3049,3 +4489,71 @@
 	fontwidthmask:		FONTWIDTH(4)|FONTWIDTH(8)|FONTWIDTH(12)|FONTWIDTH(16)
 };
 #endif
+
+#ifdef FBCON_HAS_CFB16
+
+
+static void fbcon_radeon16_clear(struct vc_data *conp, struct display *p,
+			       int srcy, int srcx, int height, int width)
+{
+	struct radeonfb_info *rinfo = (struct radeonfb_info *)(p->fb_info);
+	u32 clr;
+
+	clr = ((u16 *)p->dispsw_data)[attr_bgcol_ec(p, conp)];
+	clr |= (clr << 16);
+
+	srcx *= fontwidth(p);
+	srcy *= fontheight(p);
+	width *= fontwidth(p);
+	height *= fontheight(p);
+
+	radeon_rectfill(rinfo, srcy, srcx, height, width, clr);
+}
+
+
+
+static struct display_switch fbcon_radeon16 = {
+	setup:			fbcon_cfb16_setup,
+	bmove:			fbcon_radeon_bmove,
+	clear:			fbcon_radeon16_clear,
+	putc:			fbcon_cfb16_putc,
+	putcs:			fbcon_cfb16_putcs,
+	revc:			fbcon_cfb16_revc,
+	clear_margins:		fbcon_cfb16_clear_margins,
+	fontwidthmask:		FONTWIDTH(4)|FONTWIDTH(8)|FONTWIDTH(12)|FONTWIDTH(16)
+};
+#endif
+
+#ifdef FBCON_HAS_CFB32
+
+
+static void fbcon_radeon32_clear(struct vc_data *conp, struct display *p,
+			       int srcy, int srcx, int height, int width)
+{
+	struct radeonfb_info *rinfo = (struct radeonfb_info *)(p->fb_info);
+	u32 clr;
+
+	clr = ((u32 *)p->dispsw_data)[attr_bgcol_ec(p, conp)];
+
+	srcx *= fontwidth(p);
+	srcy *= fontheight(p);
+	width *= fontwidth(p);
+	height *= fontheight(p);
+
+	radeon_rectfill(rinfo, srcy, srcx, height, width, clr);
+}
+
+
+
+static struct display_switch fbcon_radeon32 = {
+	setup:			fbcon_cfb32_setup,
+	bmove:			fbcon_radeon_bmove,
+	clear:			fbcon_radeon32_clear,
+	putc:			fbcon_cfb32_putc,
+	putcs:			fbcon_cfb32_putcs,
+	revc:			fbcon_cfb32_revc,
+	clear_margins:		fbcon_cfb32_clear_margins,
+	fontwidthmask:		FONTWIDTH(4)|FONTWIDTH(8)|FONTWIDTH(12)|FONTWIDTH(16)
+};
+#endif
+
Index: drivers/video/skeletonfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/skeletonfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/skeletonfb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/skeletonfb.c	23 Aug 2005 23:28:43 -0000	1.2
@@ -30,7 +30,7 @@
      */
 
 
-struct xxxfb_info {
+struct ts7kvfb_info {
     /*
      *  Choose _one_ of the two alternatives:
      *
@@ -40,7 +40,7 @@
     /*
      *    2. Provide your own frame buffer operations.
      */
-    struct fb_info info;
+    //struct fb_info info;
 
     /* Here starts the frame buffer device dependent part */
     /* You can use this to store e.g. the board number if you support */
@@ -48,7 +48,7 @@
 };
 
 
-struct xxxfb_par {
+struct ts7kvfb_par {
     /*
      *  The hardware specific data in this structure uniquely defines a video
      *  mode.
@@ -63,8 +63,8 @@
      *  or allocate them dynamically (using kmalloc()).
      */
 
-static struct xxxfb_info fb_info;
-static struct xxxfb_par current_par;
+static struct ts7kvfb_info fb_info;
+static struct ts7kvfb_par current_par;
 static int current_par_valid = 0;
 static struct display disp;
 
@@ -73,27 +73,27 @@
 static int currcon = 0;
 static int inverse = 0;
 
-int xxxfb_init(void);
-int xxxfb_setup(char*);
+int ts7kvfb_init(void);
+int ts7kvfb_setup(char*);
 
 /* ------------------- chipset specific functions -------------------------- */
 
 
-static void xxx_detect(void)
+static void ts7kv_detect(void)
 {
     /*
      *  This function should detect the current video mode settings and store
      *  it as the default video mode
      */
 
-    struct xxxfb_par par;
+    struct ts7kvfb_par par;
 
     /* ... */
-    xxx_get_par(&par);
-    xxx_encode_var(&default_var, &par);
+    ts7kv_get_par(&par);
+    ts7kv_encode_var(&default_var, &par);
 }
 
-static int xxx_encode_fix(struct fb_fix_screeninfo *fix, struct xxxfb_par *par,
+static int ts7kv_encode_fix(struct fb_fix_screeninfo *fix, struct ts7kvfb_par *par,
 			  const struct fb_info *info)
 {
     /*
@@ -105,7 +105,7 @@
     return 0;
 }
 
-static int xxx_decode_var(struct fb_var_screeninfo *var, struct xxxfb_par *par,
+static int ts7kv_decode_var(struct fb_var_screeninfo *var, struct ts7kvfb_par *par,
 			  const struct fb_info *info)
 {
     /*
@@ -126,7 +126,7 @@
     return 0;
 }
 
-static int xxx_encode_var(struct fb_var_screeninfo *var, struct xxxfb_par *par,
+static int ts7kv_encode_var(struct fb_var_screeninfo *var, struct ts7kvfb_par *par,
 			  const struct fb_info *info)
 {
     /*
@@ -138,7 +138,7 @@
     return 0;
 }
 
-static void xxx_get_par(struct xxxfb_par *par, const struct fb_info *info)
+static void ts7kv_get_par(struct ts7kvfb_par *par, const struct fb_info *info)
 {
     /*
      *  Fill the hardware's 'par' structure.
@@ -151,7 +151,7 @@
     }
 }
 
-static void xxx_set_par(struct xxxfb_par *par, const struct fb_info *info)
+static void ts7kv_set_par(struct ts7kvfb_par *par, const struct fb_info *info)
 {
     /*
      *  Set the hardware according to 'par'.
@@ -162,7 +162,7 @@
     /* ... */
 }
 
-static int xxx_getcolreg(unsigned regno, unsigned *red, unsigned *green,
+static int ts7kv_getcolreg(unsigned regno, unsigned *red, unsigned *green,
 			 unsigned *blue, unsigned *transp,
 			 const struct fb_info *info)
 {
@@ -176,7 +176,7 @@
     return 0;
 }
 
-static int xxx_setcolreg(unsigned regno, unsigned red, unsigned green,
+static int ts7kv_setcolreg(unsigned regno, unsigned red, unsigned green,
 			 unsigned blue, unsigned transp,
 			 const struct fb_info *info)
 {
@@ -212,8 +212,8 @@
     return 0;
 }
 
-static int xxx_pan_display(struct fb_var_screeninfo *var,
-			   struct xxxfb_par *par, const struct fb_info *info)
+static int ts7kv_pan_display(struct fb_var_screeninfo *var,
+			   struct ts7kvfb_par *par, const struct fb_info *info)
 {
     /*
      *  Pan (or wrap, depending on the `vmode' field) the display using the
@@ -225,7 +225,7 @@
     return 0;
 }
 
-static int xxx_blank(int blank_mode, const struct fb_info *info)
+static int ts7kv_blank(int blank_mode, const struct fb_info *info)
 {
     /*
      *  Blank the screen if blank_mode != 0, else unblank. If blank == NULL
@@ -242,7 +242,7 @@
     return 0;
 }
 
-static void xxx_set_disp(const void *par, struct display *disp,
+static void ts7kv_set_disp(const void *par, struct display *disp,
 			 struct fb_info_gen *info)
 {
     /*
@@ -285,10 +285,10 @@
 /* ------------ Interfaces to hardware functions ------------ */
 
 
-struct fbgen_hwswitch xxx_switch = {
-    xxx_detect, xxx_encode_fix, xxx_decode_var, xxx_encode_var, xxx_get_par,
-    xxx_set_par, xxx_getcolreg, xxx_setcolreg, xxx_pan_display, xxx_blank,
-    xxx_set_disp
+struct fbgen_hwswitch ts7kv_switch = {
+    ts7kv_detect, ts7kv_encode_fix, ts7kv_decode_var, ts7kv_encode_var, ts7kv_get_par,
+    ts7kv_set_par, ts7kv_getcolreg, ts7kv_setcolreg, ts7kv_pan_display, ts7kv_blank,
+    ts7kv_set_disp
 };
 
 
@@ -300,18 +300,18 @@
      *  Initialization
      */
 
-int __init xxxfb_init(void)
+int __init ts7kvfb_init(void)
 {
-    fb_info.gen.fbhw = &xxx_switch;
+    fb_info.gen.fbhw = &ts7kv_switch;
     fb_info.gen.fbhw->detect();
     strcpy(fb_info.gen.info.modename, "XXX");
     fb_info.gen.info.changevar = NULL;
     fb_info.gen.info.node = -1;
-    fb_info.gen.info.fbops = &xxxfb_ops;
+    fb_info.gen.info.fbops = &ts7kvfb_ops;
     fb_info.gen.info.disp = &disp;
-    fb_info.gen.info.switch_con = &xxxfb_switch;
-    fb_info.gen.info.updatevar = &xxxfb_update_var;
-    fb_info.gen.info.blank = &xxxfb_blank;
+    fb_info.gen.info.switch_con = &ts7kvfb_switch;
+    fb_info.gen.info.updatevar = &ts7kvfb_update_var;
+    fb_info.gen.info.blank = &ts7kvfb_blank;
     fb_info.gen.info.flags = FBINFO_FLAG_DEFAULT;
     /* This should give a reasonable default video mode */
     fbgen_get_var(&disp.var, -1, &fb_info.gen.info);
@@ -333,7 +333,7 @@
      *  Cleanup
      */
 
-void xxxfb_cleanup(struct fb_info *info)
+void ts7kvfb_cleanup(struct fb_info *info)
 {
     /*
      *  If your driver supports multiple boards, you should unregister and
@@ -349,9 +349,9 @@
      *  Setup
      */
 
-int __init xxxfb_setup(char *options)
+int __init ts7kvfb_setup(char *options)
 {
-    /* Parse user speficied options (`video=xxxfb:') */
+    /* Parse user speficied options (`video=ts7kvfb:') */
 }
 
 
@@ -363,13 +363,13 @@
      */
 
 /* If all you need is that - just don't define ->fb_open */
-static int xxxfb_open(const struct fb_info *info, int user)
+static int ts7kvfb_open(const struct fb_info *info, int user)
 {
     return 0;
 }
 
 /* If all you need is that - just don't define ->fb_release */
-static int xxxfb_release(const struct fb_info *info, int user)
+static int ts7kvfb_release(const struct fb_info *info, int user)
 {
     return 0;
 }
@@ -380,17 +380,17 @@
      *  However, you're free to fill in your own replacements.
      */
 
-static struct fb_ops xxxfb_ops = {
+static struct fb_ops ts7kvfb_ops = {
 	owner:		THIS_MODULE,
-	fb_open:	xxxfb_open,    /* only if you need it to do something */
-	fb_release:	xxxfb_release, /* only if you need it to do something */
+	fb_open:	ts7kvfb_open,    /* only if you need it to do something */
+	fb_release:	ts7kvfb_release, /* only if you need it to do something */
 	fb_get_fix:	fbgen_get_fix,
 	fb_get_var:	fbgen_get_var,
 	fb_set_var:	fbgen_set_var,
 	fb_get_cmap:	fbgen_get_cmap,
 	fb_set_cmap:	fbgen_set_cmap,
 	fb_pan_display:	fbgen_pan_display,
-	fb_ioctl:	xxxfb_ioctl,   /* optional */
+	fb_ioctl:	ts7kvfb_ioctl,   /* optional */
 };
 
 
@@ -405,11 +405,11 @@
 MODULE_LICENSE("GPL");
 int init_module(void)
 {
-    return xxxfb_init();
+    return ts7kvfb_init();
 }
 
 void cleanup_module(void)
 {
-    xxxfb_cleanup(void);
+    ts7kvfb_cleanup(void);
 }
 #endif /* MODULE */
Index: drivers/video/sstfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/sstfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/sstfb.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/sstfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -15,7 +15,7 @@
  *     (enable driver on big-endian machines (hppa), ioctl fixes)
  *
  *
- * $Id: sstfb.c,v 1.1 2004/07/22 19:50:23 joff Exp $
+ * $Id: sstfb.c,v 1.2 2004/08/04 01:29:58 joff Exp $
  */
 
 /*
@@ -1821,6 +1821,8 @@
 	sst_info = (struct sstfb_info*)kmalloc(sizeof(*sst_info), GFP_KERNEL);
 	if (!sst_info)
 		goto fail_kmalloc;
+	memset(sst_info, 0, sizeof(*sst_info));
+	
 	pci_set_drvdata(pdev, sst_info);
 	sst_info->type = id->driver_data;
 	spec = &voodoo_spec[sst_info->type];
Index: drivers/video/sstfb.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/sstfb.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/sstfb.h	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/sstfb.h	4 Aug 2004 01:29:58 -0000	1.2
@@ -5,7 +5,7 @@
  *
  *     Created 28 Aug 2001 by Ghozlane Toumi
  *
- * $Id: sstfb.h,v 1.1 2004/07/22 19:50:23 joff Exp $
+ * $Id: sstfb.h,v 1.2 2004/08/04 01:29:58 joff Exp $
  */
 
 
Index: drivers/video/tcxfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/tcxfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/tcxfb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/tcxfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: tcxfb.c,v 1.1 2004/07/22 19:50:22 joff Exp $
+/* $Id: tcxfb.c,v 1.2 2004/08/04 01:29:58 joff Exp $
  * tcxfb.c: TCX 24/8bit frame buffer driver
  *
  * Copyright (C) 1996,1998 Jakub Jelinek (jj@ultra.linux.cz)
Index: drivers/video/tdfxfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/tdfxfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/tdfxfb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/tdfxfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -764,7 +764,11 @@
    tdfx_outl(SRCXY,     0);
    tdfx_outl(DSTXY,     xx | (yy << 16));
    tdfx_outl(COMMAND_2D, COMMAND_2D_H2S_BITBLT | (ROP_COPY << 24));
+#ifdef __BIG_ENDIAN
+   tdfx_outl(SRCFORMAT, 0x400000 | BIT(20) );   
+#else
    tdfx_outl(SRCFORMAT, 0x400000);
+#endif
    tdfx_outl(DSTFORMAT, fmt);
    tdfx_outl(DSTSIZE,   fontwidth(p) | (fontheight(p) << 16));
    i=fontheight(p);
@@ -822,7 +826,11 @@
    tdfx_outl(COMMAND_3D, COMMAND_3D_NOP);
    tdfx_outl(COLORFORE, fgx);
    tdfx_outl(COLORBACK, bgx);
+#ifdef __BIG_ENDIAN
+   tdfx_outl(SRCFORMAT, 0x400000 | BIT(20) );   
+#else
    tdfx_outl(SRCFORMAT, 0x400000);
+#endif   
    tdfx_outl(DSTFORMAT, fmt);
    tdfx_outl(DSTSIZE, w | (h << 16));
    tdfx_outl(SRCXY,     0);
@@ -1475,6 +1483,7 @@
 #if defined(__BIG_ENDIAN)
   switch (par->bpp) {
     case 8:
+    case 24:
       reg.miscinit0 &= ~(1 << 30);
       reg.miscinit0 &= ~(1 << 31);
       break;
@@ -1482,7 +1491,6 @@
       reg.miscinit0 |= (1 << 30);
       reg.miscinit0 |= (1 << 31);
       break;
-    case 24:
     case 32:
       reg.miscinit0 |= (1 << 30);
       reg.miscinit0 &= ~(1 << 31);
@@ -1635,10 +1643,6 @@
     v.blue.length  = 5;
     break;
   case 24:
-    v.red.offset=16;
-    v.green.offset=8;
-    v.blue.offset=0;
-    v.red.length = v.green.length = v.blue.length = 8;
   case 32:
     v.red.offset   = 16;
     v.green.offset = 8;
@@ -1942,6 +1946,12 @@
 			break;
 	}
 	
+        if (pci_enable_device(pdev)) 
+        {
+                printk(KERN_WARNING "fb: Unable to enable %s PCI device.\n", name);
+                return -ENXIO;
+        }
+
 	fb_info.regbase_phys = pci_resource_start(pdev, 0);
 	fb_info.regbase_size = 1 << 24;
 	fb_info.regbase_virt = ioremap_nocache(fb_info.regbase_phys, 1 << 24);
@@ -1970,6 +1980,13 @@
 
 	fb_info.iobase = pci_resource_start (pdev, 2);
       
+        if (!fb_info.iobase) {
+	        printk(KERN_WARNING "fb: Can't access %s I/O ports.\n", name);
+		iounmap(fb_info.regbase_virt);
+		iounmap(fb_info.bufbase_virt);
+                return -ENXIO;
+	}
+   
 	printk("fb: %s memory = %ldK\n", name, fb_info.bufbase_size >> 10);
 
 #ifdef CONFIG_MTRR
@@ -2363,10 +2380,25 @@
    unsigned int h,to;
 
    tdfxfb_createcursorshape(p);
-   xline = ~((1 << (32 - fb_info.cursor.w)) - 1);
+   xline = (~0) << (32 - fb_info.cursor.w);
 
 #ifdef __LITTLE_ENDIAN
    xline = swab32(xline);
+#else
+   switch (p->var.bits_per_pixel) {
+      case 8:
+      case 24:
+         xline = swab32(xline);
+         break;
+      case 16:
+         xline = ((xline & 0xff000000 ) >> 16 )
+               | ((xline & 0x00ff0000 ) >> 16 )
+               | ((xline & 0x0000ff00 ) << 16 )
+               | ((xline & 0x000000ff ) << 16 );
+         break;
+      case 32:
+         break;
+   }
 #endif
 
    cursorbase=(u8*)fb_info.bufbase_virt;
Index: drivers/video/tgafb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/tgafb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/tgafb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/tgafb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *	Copyright (C) 1999,2000 Martin Lucina, Tom Zerucha
  *  
- *  $Id: tgafb.c,v 1.1 2004/07/22 19:50:22 joff Exp $
+ *  $Id: tgafb.c,v 1.2 2004/08/04 01:29:58 joff Exp $
  *
  *  This driver is partly based on the original TGA framebuffer device, which 
  *  was partly based on the original TGA console driver, which are
Index: drivers/video/tgafb.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/tgafb.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/tgafb.h	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/tgafb.h	4 Aug 2004 01:29:58 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *  	Copyright (C) 1999,2000 Martin Lucina, Tom Zerucha
  *  
- *  $Id: tgafb.h,v 1.1 2004/07/22 19:50:22 joff Exp $
+ *  $Id: tgafb.h,v 1.2 2004/08/04 01:29:58 joff Exp $
  *
  *  This file is subject to the terms and conditions of the GNU General Public
  *  License. See the file COPYING in the main directory of this archive for
Index: drivers/video/ts7300fb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/ts7300fb.c,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/video/ts7300fb.c	23 Mar 2006 20:29:10 -0000	1.1
+++ drivers/video/ts7300fb.c	28 Feb 2007 21:33:02 -0000	1.5
@@ -38,6 +38,8 @@
 	unsigned long fb_phys;
 	volatile unsigned short *fpga_regs;
 	unsigned int page;
+	unsigned int xres;
+	unsigned int yres;
 	struct { unsigned red, green, blue, pad; } palette[16];
 
 	u16 fbcon_cmap16[16];
@@ -72,9 +74,16 @@
 	unsigned short vidctrl;
 	unsigned int direction = 0;
 
+	if (height > 511) {
+		ts7300_blt(src, dest, width, 511, pxfill);
+		height -= 511;
+		if (!pxfill) src += fb_info.xres * 511;
+		dest += fb_info.xres * 511;
+	}
+
 	if (pxfill == 0 && src < dest) {
-		src += (height - 1) * XRES;
-		dest += (height - 1) * XRES;
+		src += (height - 1) * fb_info.xres;
+		dest += (height - 1) * fb_info.xres;
 		direction = 1;
 	}
 
@@ -92,8 +101,8 @@
 static void fbcon_ts7300_bmove(struct display *p, int sy, int sx, int dy, int dx,
 	                        int height, int width)
 {
-	unsigned int src = sy * fontheight(p) * XRES + sx * fontwidth(p);
-	unsigned int dst = dy * fontheight(p) * XRES + dx * fontwidth(p);
+	unsigned int src = sy * fontheight(p) * fb_info.xres + sx * fontwidth(p);
+	unsigned int dst = dy * fontheight(p) * fb_info.xres + dx * fontwidth(p);
 
 	width  *= fontwidth(p);
 	height *= fontheight(p);
@@ -104,7 +113,7 @@
 void fbcon_ts7300_clear(struct vc_data *conp, struct display *p, int sy, int sx,
                        int height, int width)
 {
-	unsigned int dst = sy * fontheight(p) * XRES + sx * fontwidth(p);
+	unsigned int dst = sy * fontheight(p) * fb_info.xres + sx * fontwidth(p);
 	unsigned short bgcolor;
 
 	width  *= fontwidth(p);
@@ -145,7 +154,7 @@
 	fix->ywrapstep = 0;
 	fix->xpanstep = 0;
 	fix->ypanstep = 0;
-	fix->line_length = XRES * 2;
+	fix->line_length = fb_info.xres * 2;
 	fix->accel = FB_ACCELF_TEXT;
 
 	return 0;
@@ -154,7 +163,7 @@
 static void set_color_bitfields(struct fb_var_screeninfo *var)
 {
 	var->red.offset = 11;
-	var->green.offset = 6;
+	var->green.offset = 5;
 	var->blue.offset = 0;
 	var->transp.offset = 0;
 
@@ -174,7 +183,7 @@
 {
 	struct ts7300fb_par *par = (struct ts7300fb_par *)_par;
 
-	if (var->xres != XRES || var->yres != YRES)
+	if (var->xres != fb_info.xres || var->yres != fb_info.yres)
 		return -EINVAL;
 
 	if(var->bits_per_pixel != BPP)
@@ -304,20 +313,50 @@
 	ts7300_set_disp
 };
 
+/* Use a bit blit to determine the screen resolution, assumes 4:3 aspect ratio*/
+int detect_screen_width()
+{
+	unsigned int i=0, found = 0;
+	unsigned short *mem = (unsigned short *) fb_info.fb_virt_start;
+
+	ts7300_blt(0xFFFF, 0, MAX_WIDTH-1, 2, 1);
+	ts7300_blt(0, 0, 1-1, 2, 1);
+
+	for(i=0;i<(MAX_WIDTH*2);i++) {
+		if(mem[i] == 0x0) found++;
+		if(found == 2) break;
+	}
+
+	if(found != 2) {
+		printk("Framebuffer doesn't support this video core\n");
+		return 0;
+	} else { //Assumes a 4:3 aspect ratio
+		fb_info.xres=i;
+		fb_info.yres=i*3/4;
+		printk("Detected %dx%d video core\n",
+		  fb_info.xres, fb_info.yres);
+	}
+
+	return 1;
+}
+
 int __init ts7300fb_init(void)
 {
 	int return_val = 0;
-	int i;
-
+	fb_info.xres = MAX_WIDTH; //we have to define these to be non null until
+	fb_info.yres = MAX_HEIGHT; //we detect the correct values
 	fb_info.fb_size = VIDEOMEMORYSIZE;
 	fb_info.fb_virt_start = __ioremap(0x72200000, 0x100000, 0);
-	fb_info.fb_phys = 0x72000000;
+	fb_info.fb_phys = 0x72200000;
 	fb_info.fpga_regs = (short *)__ioremap(0x72000030, 0x10, 0);
 
-	current_par.var.xres = XRES;
-	current_par.var.xres_virtual = XRES;
-	current_par.var.yres = YRES;
-	current_par.var.yres_virtual = YRES;
+	if(!detect_screen_width())
+		return -1;
+
+	current_par.var.xres = fb_info.xres;
+	current_par.var.xres_virtual = fb_info.xres;
+	current_par.var.yres = fb_info.yres;
+	current_par.var.yres_virtual = fb_info.yres;
 	current_par.var.bits_per_pixel = BPP;
 
 	//timing information
@@ -334,9 +373,10 @@
 	fb_info.fpga_regs[VIDCTRL] = 0x300;
 	fb_info.page = 0;
 
-	// Blank screen
-	ts7300_blt(0, 0, 639, 480, 1);
 
+	// Blank screen
+	ts7300_blt(0, 0, fb_info.xres-1, fb_info.yres, 1);
+	
 	strcpy(fb_info.gen.info.modename, "TS-7300");
 	strcpy(fb_info.gen.info.fontname, "Acorn8x8");
 	fb_info.gen.parsize = sizeof(struct ts7300fb_par);
Index: drivers/video/ts7300fb.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/ts7300fb.h,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/video/ts7300fb.h	23 Mar 2006 20:29:10 -0000	1.1
+++ drivers/video/ts7300fb.h	28 Feb 2007 21:34:17 -0000	1.3
@@ -6,8 +6,10 @@
 #define VIDCTRL 4
 #define DEVSEL  15
 
-#define XRES  640
-#define YRES  480
 #define BPP   16
 
 #define VIDEOMEMORYSIZE (1*1024*1024)
+
+//These vals need to be modified if we support a larger resolution
+#define MAX_WIDTH 1024
+#define MAX_HEIGHT 768
